<?php
namespace Teknisa\PLA\Modules\Servico\Controllers;

use Zeedhi\Framework\DTO;

class Ger04100ServicoReport extends \Zeedhi\Framework\Controller\Report {
  protected $birtStrategy;
	protected $dataSourceManager;
	protected $environment;
	protected $entityManager;
	protected $util;
	protected $connection;

	public function __construct($reportService, $birtStrategy, $environment, $entityManager, $util){
    $this->reportService	  = $reportService;
    $this->birtStrategy     = $birtStrategy;
    $this->environment      = $environment;
    $this->entityManager    = $entityManager;
    $this->util             = $util;
	}
	
  protected $reportMapping = array (
  	'GER04101' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'CDGRUPFILI'    => 'P_CDGRUPFILI',
          'TCDGRUPFILI'   => 'P_TCDGRUPFILI', 
          'L_FILIAL'      => 'L_FILIAL',
          'L_FILISERV'    => 'L_FILISERV',
          'NRORG'         => 'P_NRORG'
  	    )
	  ),
  	'GER04102' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'L_FILIAL'      => 'L_FILIAL',
          'L_FILISERV'    => 'L_FILISERV',
          'CDGRUPFILI'    => 'P_CDGRUPFILI',
          'TCDGRUPFILI'   => 'P_TCDGRUPFILI', 
          'NRORG'         => 'P_NRORG'
  	    )
	  ),
  	'GER04103' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'CDGRUPFILI'    => 'P_CDGRUPFILI',
          'TCDGRUPFILI'   => 'P_TCDGRUPFILI', 
          'L_FILIAL'      => 'L_FILIAL',
          'L_FILISERV'    => 'L_FILISERV',
          'NRORG'         => 'P_NRORG'
  	    )
	  ),
  	'GER04104' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'CDGRUPFILI'    => 'P_CDGRUPFILI',
          'TCDGRUPFILI'   => 'P_TCDGRUPFILI', 
          'L_FILIAL'      => 'L_FILIAL',
          'L_FILISERV'    => 'L_FILISERV',
          'NRORG'         => 'P_NRORG'
  	    )
	  ),
  	'GER04105' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'L_FILIAL'      => 'L_FILIAL',
          'L_FILISERV'    => 'L_FILISERV',
          'CDGRUPFILI'    => 'P_CDGRUPFILI',
          'TCDGRUPFILI'   => 'P_TCDGRUPFILI', 
          'NRORG'         => 'P_NRORG'
  	    )
	  ),
  	'GER04106' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'L_FILIAL'      => 'L_FILIAL',
          'L_FILISERV'    => 'L_FILISERV',
          'CDGRUPFILI'    => 'P_CDGRUPFILI',
          'TCDGRUPFILI'   => 'P_TCDGRUPFILI', 
          'NRORG'         => 'P_NRORG'
  	    )
	  )	  
  );
  
  public function returnFiliServ($servico){
    $servFili = array();
    foreach ($servico as $key => &$value){
      $servFili[] = $value['CDFILIAL'].$value['CDSERVFILI'];
    }
    return $servFili;
  }
  
    public function getAllUnidadesOperador() {
        $query = "
            SELECT
                F.CDFILIAL
            FROM
            FILIAL F
                JOIN
                FILIOPER FO
                ON F.CDFILIAL = FO.CDFILIAL
            WHERE
                FO.CDOPERADOR = :CDOPERADOR
            ORDER BY
                FO.CDFILIAL ASC, F.NMFILIAL ASC";
                
        $params = array(
            "CDOPERADOR" => $this->environment->getCdOperador()
        );
        $arrayUnidades = $this->entityManager->getConnection()->fetchAll($query, $params);
        $unidades = array_map(function($cdFilial) {
            return $cdFilial["CDFILIAL"];
        }, $arrayUnidades);
        
        return $unidades;
    }
    
    public function getAllServicosOperador($cdGrupFili, $cdFilial) {
      $query = "
        SELECT DISTINCT
            SERVICO.CDFILIAL,
            SERVICO.CDSERVFILI,
            FILIAL.CDFILIAL || SERVICO.CDSERVFILI AS FILISERV
        FROM
            SERVICO, FILIAL
            INNER JOIN FILIOPER    FO ON FO.CDFILIAL = FILIAL.CDFILIAL
            LEFT JOIN FILGRUPFILI FG ON FILIAL.CDFILIAL = FG.CDFILIAL
        WHERE FILIAL.CDFILIAL = SERVICO.CDFILIAL
            AND ( INSTR(:CDFILIAL, SERVICO.CDFILIAL) <> 0
                  OR :CDFILIAL = 'T' )
            AND FO.CDOPERADOR = :CDOPERADOR
            AND ( :CDGRUPFILI = FG.CDGRUPFILI
                  OR :CDGRUPFILI = 'T' )
        ORDER BY
            SERVICO.CDFILIAL,
            NLSSORT(SERVICO.CDSERVFILI, 'NLS_SORT=BINARY_AI')";
      
        $params = array(
            "CDOPERADOR"  => $this->environment->getCdOperador(),
            "CDGRUPFILI"  => $cdGrupFili,
            "CDFILIAL"    => $cdFilial
        );
        $arrayServicos = $this->entityManager->getConnection()->fetchAll($query, $params);
        
        return $arrayServicos;            
    }
  
  public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    $row = $request->getRow();
	  $row['NRORG'] = $this->environment->getNrOrg();
	  $row['NMFILIAL'] = ($row['NMFILIAL'] == "" || $row['NMFILIAL'] == []) ? self::getAllUnidadesOperador() : $row['NMFILIAL'];
	  $row['CDFILIAL'] = implode('_', $row['NMFILIAL']);
	  $row['CDGRUPFILI'] = $row['NMGRUPFILI'] == "" ? "T" : $row['CDGRUPFILI'];
	  $row['TCDGRUPFILI'] = $row['CDGRUPFILI'];
	 
	  if($row['NMSERVICO'] == [] || $row['NMSERVICO'] == "") {
	    $todosServicos = self::getAllServicosOperador($row['CDGRUPFILI'], $row['CDFILIAL']);
	    
	    $arrayServFili = array_map(function($servico){
  	    return $servico['FILISERV'];
	    }, $todosServicos);
	  } else {
      $arrayServFili = self::returnFiliServ($row['NMSERVICO']);
	  }
	  
	  $row['CDSERVFILI'] = implode('_', $arrayServFili);
	  $row['L_FILIAL'] = $this->util->insertLista($row['NMFILIAL']);
	  $row['L_FILISERV'] = $this->util->insertLista($arrayServFili);
	  
	  $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
  }
}